"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeschichteForNextjsWrapper = exports.GeschichteForNextjs = void 0;
const react_1 = __importStar(require("react"));
const shallow_1 = require("zustand/shallow");
const store_js_1 = require("../../store.js");
const router_js_1 = __importStar(require("next/router.js"));
const split = (url) => (url === null || url === void 0 ? void 0 : url.split('?')) || [];
// FIXME: Somehow imports are messed up for nextjs when importing from modules (see https://github.com/vercel/next.js/issues/36794)
const Router = router_js_1.default.default;
const queryFromPath = (path) => {
    const [, query] = split(path);
    return `?${query || ''}`;
};
const GeschichteForNextjs = ({ children, asPath, initialClientOnlyAsPath, defaultPushOptions, defaultReplaceOptions, routerPush, routerReplace, }) => {
    const lastClientSideQuery = (0, react_1.useRef)(initialClientOnlyAsPath);
    const historyInstance = (0, react_1.useMemo)(() => {
        return {
            initialSearch: () => {
                const [, query] = typeof window === 'undefined'
                    ? split(asPath)
                    : split(lastClientSideQuery.current || Router.asPath);
                return `?${query || ''}`;
            },
            push: (query, options) => {
                const [pathname] = split(Router.asPath);
                const routerOptions = {
                    ...defaultPushOptions,
                    ...options,
                };
                if (routerPush) {
                    return routerPush({ query: Router.query }, { query, pathname }, routerOptions);
                }
                return Router.push({ query: Router.query }, { query, pathname }, routerOptions);
            },
            replace: (query, options) => {
                const [pathname] = split(Router.asPath);
                const routerOptions = {
                    ...defaultReplaceOptions,
                    ...options,
                };
                if (routerReplace) {
                    return routerReplace({ query: Router.query }, { pathname, query }, routerOptions);
                }
                return Router.replace({ query: Router.query }, { pathname, query }, routerOptions);
            },
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [routerPush, routerReplace]);
    const useStore = (0, react_1.useMemo)(() => (0, store_js_1.createGeschichte)(historyInstance), [historyInstance]);
    const state = useStore(({ unregister, updateFromQuery }) => ({
        unregister,
        updateFromQuery,
    }), shallow_1.shallow);
    const { updateFromQuery } = state;
    (0, react_1.useEffect)(() => {
        // tslint:disable-next-line
        lastClientSideQuery.current = window.location.href;
        updateFromQuery(window.location.search);
        let skipEvent = true;
        const routeChangeStartHandler = (path) => {
            const nextQuery = queryFromPath(path);
            lastClientSideQuery.current = path;
            // skip execution for first render
            if (!skipEvent) {
                updateFromQuery(nextQuery);
            }
            skipEvent = false;
        };
        Router.events.on('beforeHistoryChange', routeChangeStartHandler);
        return () => {
            Router.events.off('beforeHistoryChange', routeChangeStartHandler);
        };
    }, [updateFromQuery]);
    (0, react_1.useEffect)(() => {
        const { unregister } = state;
        return () => {
            return unregister();
        };
    }, [state]);
    return (react_1.default.createElement(store_js_1.StoreContext.Provider, { value: useStore }, children));
};
exports.GeschichteForNextjs = GeschichteForNextjs;
// see https://nextjs.org/docs/api-reference/next/router#routerpush for options;
// in general we want shallow (see https://nextjs.org/docs/routing/shallow-routing) routing in most cases and not scroll
const defaultRoutingOptions = { scroll: false, shallow: true };
const GeschichteForNextjsWrapper = ({ omitQueries = true, defaultPushOptions = defaultRoutingOptions, defaultReplaceOptions = defaultRoutingOptions, ...props }) => {
    const { asPath } = (0, router_js_1.useRouter)();
    const thisAsPath = (0, react_1.useMemo)(() => {
        if (omitQueries) {
            const [path] = asPath.split('?');
            return path;
        }
        return asPath;
    }, [asPath, omitQueries]);
    const [pp, setPp] = (0, react_1.useState)(thisAsPath);
    (0, react_1.useEffect)(() => {
        // We have to render the page always as if it would be rendered without query parameters, because
        // nextjs does not include the query parameters in the cache key. To not add side effects for other clients,
        // we set the path including query parameters on client mount.
        setPp(asPath);
    }, [asPath]);
    return (react_1.default.createElement(exports.GeschichteForNextjs, { initialClientOnlyAsPath: thisAsPath, defaultReplaceOptions: defaultReplaceOptions, defaultPushOptions: defaultPushOptions, asPath: pp, ...props }));
};
exports.GeschichteForNextjsWrapper = GeschichteForNextjsWrapper;
exports.default = (0, react_1.memo)(exports.GeschichteForNextjsWrapper);
