import React, { memo, useMemo, useRef } from 'react';
import { StoreContext, createGeschichte, } from '../../store.js';
import { createSearch } from '../../utils.js';
const StaticGeschichteProvider = ({ search, children, }) => {
    const thisSearch = useRef(search);
    const historyInstance = useMemo(() => {
        return {
            initialSearch: () => thisSearch.current || '',
            push: async (query) => {
                thisSearch.current = createSearch(query);
                return;
            },
            replace: async (query) => {
                thisSearch.current = createSearch(query);
                return;
            },
        };
    }, [thisSearch]);
    const value = useMemo(() => createGeschichte(historyInstance), [historyInstance]);
    return React.createElement(StoreContext.Provider, { value: value }, children);
};
export default memo(StaticGeschichteProvider);
